#define Hg_2P_MM_Rate 3. /* yr-1 */
#define Hg_MM_2P_Dark_Rate 30.
#define Hg_MM_2P_Phot_Rate 10.
#define Hg_MM_DM_Rate 0.3
#define Hg_DM_MM_Rate 0.3
#define Hg_2P_DM_Rate 0.03
#define Hg_2P_0_Rate 2.d-2
#define Hg_0_2P_Rate 3.d-2
#define Hg_Degas_Rate 10.d0

      program test_it
      
      real a(3,3),b(3)

c-Hg_2P_MM_Rate - Hg_2P_DM_Rate - Hg_2P_0_Rate,
c      data a/
c     $             Hg_0_2P_Rate, Hg_MM_2P_Rate, 0,
c     $        Hg_2P_0_Rate, - Hg_0_2P_Rate, 0, 0,
c     $        Hg_2P_MM_Rate, 0, - Hg_MM_2P_Rate, Hg_DM_MM_Rate /

c      data b/ 0,0,0,1 /

      a = 0
      a(1,1) = - Hg_0_2P_Rate
      b(1)   = - Hg_2P_0_Rate
      a(2,2) = - Hg_MM_2P_Dark_Rate - Hg_MM_DM_Rate
      a(2,3) =   Hg_DM_MM_Rate
      b(2)   = - Hg_2P_MM_Rate
      a(3,2) =   Hg_MM_DM_Rate
      a(3,3) = - Hg_DM_MM_Rate
      b(3)   = - Hg_2P_DM_Rate

      call gaussj(a, 3, 3, b, 1, 1)

      totScale = 1d0 + b(1) + b(2) + b(3)
      frac_2p = 1d0 / totScale
      frac_0 = b(1) / totScale
      frac_mm = b(2) / totScale
      frac_dm = b(3) / totScale

      return
      end

      SUBROUTINE gaussj(a,n,np,b,m,mp)
       
C        numerical recipes, pages 28-29

       PARAMETER (nmax=4)
       DIMENSION a(np,np), b(np,mp)
       DIMENSION ipiv(nmax)
       DIMENSION indxr(nmax), indxc(nmax)
       DO 11 j=1,n
         ipiv(j)=0
 11    CONTINUE
       DO 22 i=1,n
         big=0.
         DO 13 j=1,n
           IF(ipiv(j).NE.1) then
             DO 12 k=1,n
               IF(ipiv(k).EQ.0) then
                 IF(abs(a(j,k)).ge.big) then
                   big=abs(a(j,k))
                   irow=j
                   icol=k
                 ENDIF
               ELSE IF(ipiv(k).GT.1) then
                 PAUSE 'singular matrix'
               ENDIF
 12          CONTINUE
           ENDIF
 13      CONTINUE
         ipiv(icol)=ipiv(icol)+1
         IF(irow.NE.icol) then
           DO 14 l=1,n
             dum=a(irow,l)
             a(irow,l)=a(icol,l)
             a(icol,l)=dum
 14        CONTINUE
           DO 15 l=1,m
             dum=b(irow,l)
             b(irow,l)=b(icol,l)
             b(icol,l)=dum
 15        CONTINUE
         ENDIF
         indxr(i)=irow
         indxc(i)=icol
         IF(a(icol,icol).EQ.0.) PAUSE 'singular matrix'
         pivinv=1./a(icol,icol)
         a(icol,icol)=1.
         DO 16 l=1,n
           a(icol,l)=a(icol,l)*pivinv
 16      CONTINUE
         DO 17 l=1,m
           b(icol,l)=b(icol,l)*pivinv
 17      CONTINUE
         DO 21 ll=1,n
           IF(ll.NE.icol) then
             dum=a(ll,icol)
             a(ll,icol)=0.
             DO 18 l=1,n
               a(ll,l)=a(ll,l)-a(icol,l)*dum
 18          CONTINUE
             DO 19 l=1,m
               b(ll,l)=b(ll,l)-b(icol,l)*dum
 19          CONTINUE
           ENDIF
 21      CONTINUE
 22    CONTINUE
       DO 24 l=n,1,-1
         IF(indxr(l).NE.indxc(l)) then
           DO 23 k=1,n
             dum=a(k,indxr(l))
             a(k,indxr(l))=a(k,indxc(l))
             a(k,indxc(l))=dum
 23        CONTINUE
         ENDIF
 24    CONTINUE
       RETURN
       END
